# coding: utf-8

"""

    # Authentication  <!-- ReDoc-Inject: <security-definitions> -->  # noqa: E501

    OpenAPI spec version: 0.0.0
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six

class CompetJsonldEngagement(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'context': 'OneOfCompetJsonldEngagementContext',
        'id': 'str',
        'type': 'str',
        'cp_no': 'int',
        'type': 'str',
        'name': 'str',
        'cp_tri': 'int',
        'level': 'str',
        'cdg': 'CdgJsonldEngagement'
    }

    attribute_map = {
        'context': '@context',
        'id': '@id',
        'type': '@type',
        'cp_no': 'cp_no',
        'type': 'type',
        'name': 'name',
        'cp_tri': 'cp_tri',
        'level': 'level',
        'cdg': 'cdg'
    }

    def __init__(self, context=None, id=None, type=None, cp_no=None, name=None, cp_tri=None, level=None, cdg=None):  # noqa: E501
        """CompetJsonldEngagement - a model defined in Swagger"""  # noqa: E501
        self._context = None
        self._id = None
        self._type = None
        self._cp_no = None
        self._type = None
        self._name = None
        self._cp_tri = None
        self._level = None
        self._cdg = None
        self.discriminator = None
        if context is not None:
            self.context = context
        if id is not None:
            self.id = id
        if type is not None:
            self.type = type
        if cp_no is not None:
            self.cp_no = cp_no
        if type is not None:
            self.type = type
        if name is not None:
            self.name = name
        if cp_tri is not None:
            self.cp_tri = cp_tri
        if level is not None:
            self.level = level
        if cdg is not None:
            self.cdg = cdg

    @property
    def context(self):
        """Gets the context of this CompetJsonldEngagement.  # noqa: E501


        :return: The context of this CompetJsonldEngagement.  # noqa: E501
        :rtype: OneOfCompetJsonldEngagementContext
        """
        return self._context

    @context.setter
    def context(self, context):
        """Sets the context of this CompetJsonldEngagement.


        :param context: The context of this CompetJsonldEngagement.  # noqa: E501
        :type: OneOfCompetJsonldEngagementContext
        """

        self._context = context

    @property
    def id(self):
        """Gets the id of this CompetJsonldEngagement.  # noqa: E501


        :return: The id of this CompetJsonldEngagement.  # noqa: E501
        :rtype: str
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this CompetJsonldEngagement.


        :param id: The id of this CompetJsonldEngagement.  # noqa: E501
        :type: str
        """

        self._id = id

    @property
    def type(self):
        """Gets the type of this CompetJsonldEngagement.  # noqa: E501


        :return: The type of this CompetJsonldEngagement.  # noqa: E501
        :rtype: str
        """
        return self._type

    @type.setter
    def type(self, type):
        """Sets the type of this CompetJsonldEngagement.


        :param type: The type of this CompetJsonldEngagement.  # noqa: E501
        :type: str
        """

        self._type = type

    @property
    def cp_no(self):
        """Gets the cp_no of this CompetJsonldEngagement.  # noqa: E501


        :return: The cp_no of this CompetJsonldEngagement.  # noqa: E501
        :rtype: int
        """
        return self._cp_no

    @cp_no.setter
    def cp_no(self, cp_no):
        """Sets the cp_no of this CompetJsonldEngagement.


        :param cp_no: The cp_no of this CompetJsonldEngagement.  # noqa: E501
        :type: int
        """

        self._cp_no = cp_no

    @property
    def type(self):
        """Gets the type of this CompetJsonldEngagement.  # noqa: E501


        :return: The type of this CompetJsonldEngagement.  # noqa: E501
        :rtype: str
        """
        return self._type

    @type.setter
    def type(self, type):
        """Sets the type of this CompetJsonldEngagement.


        :param type: The type of this CompetJsonldEngagement.  # noqa: E501
        :type: str
        """

        self._type = type

    @property
    def name(self):
        """Gets the name of this CompetJsonldEngagement.  # noqa: E501


        :return: The name of this CompetJsonldEngagement.  # noqa: E501
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """Sets the name of this CompetJsonldEngagement.


        :param name: The name of this CompetJsonldEngagement.  # noqa: E501
        :type: str
        """

        self._name = name

    @property
    def cp_tri(self):
        """Gets the cp_tri of this CompetJsonldEngagement.  # noqa: E501


        :return: The cp_tri of this CompetJsonldEngagement.  # noqa: E501
        :rtype: int
        """
        return self._cp_tri

    @cp_tri.setter
    def cp_tri(self, cp_tri):
        """Sets the cp_tri of this CompetJsonldEngagement.


        :param cp_tri: The cp_tri of this CompetJsonldEngagement.  # noqa: E501
        :type: int
        """

        self._cp_tri = cp_tri

    @property
    def level(self):
        """Gets the level of this CompetJsonldEngagement.  # noqa: E501


        :return: The level of this CompetJsonldEngagement.  # noqa: E501
        :rtype: str
        """
        return self._level

    @level.setter
    def level(self, level):
        """Sets the level of this CompetJsonldEngagement.


        :param level: The level of this CompetJsonldEngagement.  # noqa: E501
        :type: str
        """

        self._level = level

    @property
    def cdg(self):
        """Gets the cdg of this CompetJsonldEngagement.  # noqa: E501


        :return: The cdg of this CompetJsonldEngagement.  # noqa: E501
        :rtype: CdgJsonldEngagement
        """
        return self._cdg

    @cdg.setter
    def cdg(self, cdg):
        """Sets the cdg of this CompetJsonldEngagement.


        :param cdg: The cdg of this CompetJsonldEngagement.  # noqa: E501
        :type: CdgJsonldEngagement
        """

        self._cdg = cdg

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(CompetJsonldEngagement, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, CompetJsonldEngagement):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
